;getDI(185 Bytes)
;getDI is wrapper subroutine of Direct Input.
;Return value of key code is same as "_getcsc".
;And the new constants of a slant were added.
;It's so useful when you make fast pace's game!
;
;Inputs   : None
;Outputs  : A = KeyCode(same as "_getcsc")
;Destroies: F
;
;	Written by YUKI. [http://www.ticalc.org/archives/files/authors/70/7071.html]
;
skDownLeft = 05h
skDownRight = 06h
skUpLeft = 07h
skUpRight = 08h

getDI:	push bc
	push de
	push hl
	ld a,$FF ;reset
	out (1),a

	ld a,$FE ;group1
	out (1),a
	in a,(1)
	ld bc,8
	ld hl,getdif1
	cpir
	ld a,$01
	ld b,7
	jp z,getdig

	ld a,$FD ;group2
	out (1),a
	in a,(1)
	ld bc,7
	ld hl,getdif2
	cpir
	ld a,$09
	ld b,6
	jp z,getdig

	ld a,$FB ;group3
	out (1),a
	in a,(1)
	ld bc,7
	ld hl,getdif2
	cpir
	ld a,$11
	ld b,6
	jp z,getdig

	ld a,$F7 ;group4
	out (1),a
	in a,(1)
	ld bc,8
	ld hl,getdif2
	cpir
	ld a,$19
	ld b,7
	jp z,getdig

	ld a,$EF ;group5
	out (1),a
	in a,(1)
	ld bc,8
	ld hl,getdif2
	cpir
	ld a,$21
	ld b,7
	jp z,getdig

	ld a,$DF ;group6
	out (1),a
	in a,(1)
	ld bc,7
	ld hl,getdif2+1
	cpir
	ld a,$2A
	ld b,6
	jp z,getdig

	ld a,$BF ;group7
	out (1),a
	in a,(1)
	ld bc,8
	ld hl,getdif2
	cpir
	ld a,$31
	ld b,7
	jp z,getdig

	xor a
	pop hl
	pop de
	pop bc
	ret

getdig:	push af
	ld a,b
	sub c
	ld b,a
	pop af
	add a,b

	pop hl
	pop de
	pop bc
	ret

getdif1:.db 254,253,251,247,252,250,245,243
getdif2:.db 254,253,251,247,239,223,191,127

